
#ifndef _WEKTOR_H
#define _WEKTOR_H

const int max_rozmiar = 20;

template <class T>
class Wektor
{
protected:
	int ile_elemntow;
	int rozmiar_tablicy;
	T* tablica_elemntow;
public:

	Wektor(int r=max_rozmiar);
	Wektor(const Wektor &);
	T &operator[](int i);
	void Dodaj(const T&);
	void Usun(){ if(ile_elemntow > 0) ile_elemntow-- ; };
	int Rozmiar(){ return rozmiar_tablicy; };
	int IleElementow(){ return ile_elemntow; };
	void Wyczysc(){ ile_elemntow = 0;};
	~Wektor(){ delete [] tablica_elemntow; };

	typedef T* iterator;
	iterator begin(){ return tablica_elemntow; }
	iterator end(){ return tablica_elemntow+ile_elemntow; }
};

template <class T>
Wektor<T>::Wektor(int r):rozmiar_tablicy(r),ile_elemntow(0)
{ 
		tablica_elemntow =  new T[rozmiar_tablicy];
}

template <class T>
T& Wektor<T>::operator [](int ind)
{
	return tablica_elemntow[ind]; 
}

template <class T>
void Wektor<T>::Dodaj(const T& t)
{
	if(ile_elemntow == rozmiar_tablicy) 
   {
      rozmiar_tablicy *= 2;
	   T* tmp =  new T[rozmiar_tablicy];
	   for(int i=0;i<ile_elemntow;i++) tmp[i]=tablica_elemntow[i];
	   delete [] tablica_elemntow;
	   tablica_elemntow = tmp;
   }
   tablica_elemntow[ile_elemntow]=t;
	ile_elemntow++;
}

template<class T>
Wektor<T>::Wektor(const Wektor& w):rozmiar_tablicy(w.rozmiar_tablicy),ile_elemntow(w.ile_elemntow)
{
	tablica_elemntow= new T[rozmiar_tablicy];
	for(int i=0;i<ile_elemntow;i++) tablica_elemntow[i]=w.tablica_elemntow[i];
}

#endif
